//+------------------------------------------------------------------+
//|                                                    adx trend.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-station.com"

#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     clrDeepSkyBlue  
#property indicator_color2     clrDeepSkyBlue
#property indicator_color3     clrOrange
#property indicator_color4     clrOrange
#property indicator_color5     clrDeepSkyBlue
#property indicator_color6     clrOrange
#property indicator_width1     3
#property indicator_width3     3
#property indicator_width5     3
#property indicator_width6     3
#property indicator_level1     0
#property indicator_levelcolor clrDimGray
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2, // Heiken ashi trend biased (extreme) price
   pr_habclose,   // Heiken ashi (better formula) close
   pr_habopen ,   // Heiken ashi (better formula) open
   pr_habhigh,    // Heiken ashi (better formula) high
   pr_hablow,     // Heiken ashi (better formula) low
   pr_habmedian,  // Heiken ashi (better formula) median
   pr_habtypical, // Heiken ashi (better formula) typical
   pr_habweighted,// Heiken ashi (better formula) weighted
   pr_habaverage, // Heiken ashi (better formula) average
   pr_habmedianb, // Heiken ashi (better formula) median body
   pr_habtbiased, // Heiken ashi (better formula) trend biased price
   pr_habtbiased2 // Heiken ashi (better formula) trend biased (extreme) price
};

extern ENUM_TIMEFRAMES    TimeFrame              = PERIOD_CURRENT;   // Time frame
extern double             PTPeriod               = 10;               // Adx trend period
extern enPrices           PTPrice                = pr_habmedian   ;  // Price to use 
extern bool               alertsOn               = false;            // Turn alerts on?
extern bool               alertsOnCurrent        = false;            // Alerts on still opened bar?
extern bool               alertsMessage          = true;             // Alerts should display message?
extern bool               alertsSound            = false;            // Alerts should play a sound?
extern bool               alertsNotify           = false;            // Alerts should send a notification?
extern bool               alertsEmail            = false;            // Alerts should send an email?
extern string             soundFile              = "alert2.wav";     // Sound file
extern bool               arrowsVisible          = false;            // Arrows visible?
extern bool               arrowsOnNewest         = false;            // Arrows drawn on newest bar of higher time frame bar?
extern string             arrowsIdentifier       = "adx Arrows1";    // Unique ID for arrows
extern double             arrowsUpperGap         = 1.0;              // Upper arrow gap
extern double             arrowsLowerGap         = 1.0;              // Lower arrow gap
extern color              arrowsUpColor          = clrLimeGreen;     // Up arrow color
extern color              arrowsDnColor          = clrOrange;        // Down arrow color
extern int                arrowsUpCode           = 241;              // Up arrow code
extern int                arrowsDnCode           = 242;              // Down arrow code
extern int                arrowsSize             = 0;                // Arrows size
extern bool               Interpolate            = true;             // Interpolate in mtf mode

double ptlup[],ptldn[],pthuu[],pthdd[],pthud[],pthdu[],adxup[],adxdn[],trend[],count[];
string indicatorFileName;
#define _mtfCall(_buff,_ind) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,PTPeriod,PTPrice,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,arrowsVisible,arrowsOnNewest,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,_buff,_ind)

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(10);
   for (int i=0; i<indicator_buffers; i++) SetIndexStyle(i,DRAW_LINE);
   SetIndexBuffer(0,pthuu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,pthud); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,pthdd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,pthdu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,ptlup);
   SetIndexBuffer(5,ptldn);
   SetIndexBuffer(6,adxup);
   SetIndexBuffer(7,adxdn);
   SetIndexBuffer(8,trend);
   SetIndexBuffer(9,count);

   indicatorFileName = WindowExpertName();
   TimeFrame         = fmax(TimeFrame,_Period);
   
   IndicatorShortName(timeFrameToString(TimeFrame)+" adx trend ("+DoubleToStr(PTPeriod,2)+")");
return(0);
}
int deinit()
{
    string lookFor       = arrowsIdentifier+":";
    int    lookForLength = StringLen(lookFor);
    for (int i=ObjectsTotal()-1; i>=0; i--)
    {
       string objectName = ObjectName(i);
          if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
    }
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double  work[][5];
#define prc 0
#define pdm 1
#define mdm 2
#define pdi 3
#define mdi 4

int start()
{
    int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = fmin(Bars-counted_bars,Bars-1); count[0] = limit;
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         if (TimeFrame != _Period)
         {
            limit = (int)fmax(limit,fmin(Bars-1,_mtfCall(9,0)*TimeFrame/_Period));
            for (i=limit;i>=0 && !_StopFlag; i--)
            {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     ptlup[i] = _mtfCall(4,y);
   	               ptldn[i] = _mtfCall(5,y);
   	               adxup[i] = _mtfCall(6,y);
   	               adxdn[i] = _mtfCall(7,y);
                     trend[i] = _mtfCall(8,y);
                     
                     //
                     //
                     //
                     //
                     //
                     
                      if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                      #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                      int n,k; datetime time = iTime(NULL,TimeFrame,y);
                         for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                         for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                         {
                            _interpolate(ptlup);
                            _interpolate(ptldn);
                         }
            }
            for(i=limit; i>=0; i--) 
            {
   	         pthuu[i] = (trend[i] == 1 && adxup[i] == 1) ? ptlup[i] : EMPTY_VALUE;
               pthud[i] = (trend[i] == 1 && adxup[i] ==-1) ? ptlup[i] : EMPTY_VALUE;
               pthdd[i] = (trend[i] ==-1 && adxdn[i] ==-1) ? ptldn[i] : EMPTY_VALUE;
               pthdu[i] = (trend[i] ==-1 && adxdn[i] == 1) ? ptldn[i] : EMPTY_VALUE;  
            }
      return(0);
      }
      
      //
      //
      //
      //
      //
      
      for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
      {
        if (i<Bars-1)
        {
           work[r][prc] = getPrice(PTPrice,Open,Close,High,Low,i,Bars);
           double diff = (i<Bars-1) ? work[r][prc]-work[r-1][prc] : 0;
           double tpdm = (diff>0) ?  diff : 0;
           double tmdm = (diff<0) ? -diff : 0;
           work[r][pdm] = (i<Bars-1) ? ((PTPeriod-1.0)*work[r-1][pdm]+tpdm)/PTPeriod : tpdm;
           work[r][mdm] = (i<Bars-1) ? ((PTPeriod-1.0)*work[r-1][mdm]+tmdm)/PTPeriod : tmdm;

           //
           //
           //
           //
           //

           double trueRange = work[r][pdm]+work[r][mdm];
           double tpdi  = (trueRange>0) ? work[r][pdm]/trueRange : 0;
           double tmdi  = (trueRange>0) ? work[r][mdm]/trueRange : 0;
           work[r][pdi] = ((PTPeriod-1.0)*work[r-1][pdi]+tpdi)/PTPeriod;
           work[r][mdi] = ((PTPeriod-1.0)*work[r-1][mdi]+tmdi)/PTPeriod;
           ptlup[i] = work[r][pdi]-0.5;
           ptldn[i] = work[r][mdi]-0.5;
           trend[i] = (i<Bars-1) ? (ptlup[i]>ptldn[i])    ? 1 : (ptlup[i]<ptldn[i])    ? -1 : trend[i+1] : 0;  
           adxup[i] = (i<Bars-1) ? (ptlup[i]>ptlup[i+1])  ? 1 : (ptlup[i]<ptlup[i+1])  ? -1 : adxup[i+1] : 0;  
           adxdn[i] = (i<Bars-1) ? (ptldn[i]>ptldn[i+1])  ? 1 : (ptldn[i]<ptldn[i+1])  ? -1 : adxdn[i+1] : 0;  
           pthuu[i] = (trend[i] == 1 && adxup[i] == 1) ? ptlup[i] : EMPTY_VALUE;
           pthud[i] = (trend[i] == 1 && adxup[i] ==-1) ? ptlup[i] : EMPTY_VALUE;
           pthdd[i] = (trend[i] ==-1 && adxdn[i] ==-1) ? ptldn[i] : EMPTY_VALUE;
           pthdu[i] = (trend[i] ==-1 && adxdn[i] == 1) ? ptldn[i] : EMPTY_VALUE;  
         
           //
           //
           //
           //
           //
                
           if (arrowsVisible)
           {
              string lookFor = arrowsIdentifier+":"+(string)Time[i]; ObjectDelete(lookFor);            
              if (i<(Bars-1) && trend[i] != trend[i+1])
              {
                 if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                 if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
              }
           }
        }
   }
   if (alertsOn)
   {
         int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert(" up ");
         else  doAlert(" down ");       
   }       
return(0);
}
   
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _prHABF(_prtype) (_prtype>=pr_habclose && _prtype<=pr_habtbiased2)
#define _priceInstances     1
#define _priceInstancesSize 4
double  _priceWorkHa[][_priceInstances*_priceInstancesSize];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int bars, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(_priceWorkHa,0)!= Bars) ArrayResize(_priceWorkHa,Bars); instanceNo*=_priceInstancesSize; int r = #ifdef __MQL4__ bars-i-1 #else i #endif;
         
         //
         //
         //
         //
         //
         
         double haOpen  = (r>0) ? (_priceWorkHa[r-1][instanceNo+2] + _priceWorkHa[r-1][instanceNo+3])/2.0 : (open[i]+close[i])/2;;
         double haClose = (open[i]+high[i]+low[i]+close[i]) / 4.0;
         if (_prHABF(tprice))
               if (high[i]!=low[i])
                     haClose = (open[i]+close[i])/2.0+(((close[i]-open[i])/(high[i]-low[i]))*MathAbs((close[i]-open[i])/2.0));
               else  haClose = (open[i]+close[i])/2.0; 
         double haHigh  = fmax(high[i], fmax(haOpen,haClose));
         double haLow   = fmin(low[i] , fmin(haOpen,haClose));

         //
         //
         //
         //
         //
         
         if(haOpen<haClose) { _priceWorkHa[r][instanceNo+0] = haLow;  _priceWorkHa[r][instanceNo+1] = haHigh; } 
         else               { _priceWorkHa[r][instanceNo+0] = haHigh; _priceWorkHa[r][instanceNo+1] = haLow;  } 
                              _priceWorkHa[r][instanceNo+2] = haOpen;
                              _priceWorkHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:
            case pr_habclose:    return(haClose);
            case pr_haopen:   
            case pr_habopen:     return(haOpen);
            case pr_hahigh: 
            case pr_habhigh:     return(haHigh);
            case pr_halow:    
            case pr_hablow:      return(haLow);
            case pr_hamedian:
            case pr_habmedian:   return((haHigh+haLow)/2.0);
            case pr_hamedianb:
            case pr_habmedianb:  return((haOpen+haClose)/2.0);
            case pr_hatypical:
            case pr_habtypical:  return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:
            case pr_habweighted: return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:  
            case pr_habaverage:  return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
            case pr_habtbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
            case pr_habtbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool tup)
{
   string name = arrowsIdentifier+":"+(string)Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //

      datetime time = Time[i]; if (arrowsOnNewest) time += _Period*60-1;      
      ObjectCreate(name,OBJ_ARROW,0,time,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_WIDTH,arrowsSize);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (tup)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

       //
       //
       //
       //
       //
      
       message = timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" adx trend "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(_Symbol+" adx trend ",message);
          if (alertsSound)   PlaySound(soundFile);
       
   }
}

